/*
 * $Id: La2.as,v 1.1.1.1 2007/04/01 08:25:41 kenta Exp $
 *
 * Copyright 2007 Kenta Cho. Some rights reserved.
 */
package {
  import flash.display.Sprite;
  import flash.display.Bitmap;
  import flash.display.BitmapData;
  import flash.events.Event;
  import flash.events.MouseEvent;
  import flash.events.KeyboardEvent;
  import flash.media.Sound;
  import abagames.util.MouseState;
  import abagames.util.KeyState;
  import abagames.la2.MainLoop;

  /**
   * La2 bootstrap.
   */
  public class La2 extends Sprite {
    [Embed(source='sounds/la2_1.mp3')]
    private var SoundBgm:Class;
    [Embed(source='sounds/flying.mp3')]
    private var SoundFlying:Class;
    [Embed(source='sounds/remove.mp3')]
    private var SoundRemove:Class;
    [Embed(source='sounds/destroyed.mp3')]
    private var SoundDestroyed:Class;
    public static const SCREEN_WIDTH:int = 360;
    public static const SCREEN_HEIGHT:int = 360;
    private var rootSprite:Sprite;
    private var mainLoop:MainLoop;
    private var keyState:KeyState;
    private var isFirst:Boolean = true;
    private var sounds:Array;

    public function La2() {
      sounds = new Array;
      sounds.push(new SoundBgm);
      sounds.push(new SoundFlying);
      sounds.push(new SoundRemove);
      sounds.push(new SoundDestroyed);
      addEventListener(Event.ENTER_FRAME, onEnterFrame);
    }

    public function onEnterFrame(evt:Event):void {
      if (isFirst) {
        isFirst = false;
        mainLoop = new MainLoop;
        keyState = new KeyState;
        rootSprite = this;
        stage.addEventListener(KeyboardEvent.KEY_DOWN, keyState.onKeyDown);
        stage.addEventListener(KeyboardEvent.KEY_UP, keyState.onKeyUp);
        var buffer:BitmapData = new BitmapData(SCREEN_WIDTH, SCREEN_HEIGHT, false, 0);
        var screen:Bitmap = new Bitmap(buffer);
        rootSprite.addChild(screen);
        mainLoop.init(rootSprite, keyState, buffer, screen, sounds);
      }
      mainLoop.update();
    }
  }
}
