/*
 * $Id: BulletPool.as,v 1.2 2007/04/04 13:08:57 kenta Exp $
 *
 * Copyright 2007 Kenta Cho. Some rights reserved.
 */
package abagames.la2 {
  import flash.display.BitmapData;
  import abagames.util.Actor;
  import abagames.util.ActorPool;
  import abagames.util.Vector;

  /**
   * Bullet pool.
   */
  public class BulletPool extends ActorPool {
    private var buffer:BitmapData;
    private var player:Player;
    private var field:Field;
    private var background:Background;
    private var particles:ParticlePool;
 
    public function BulletPool(n:int, buffer:BitmapData, player:Player,
                             field:Field, background:Background,
                             particles:ParticlePool) {
      this.buffer = buffer;
      this.player = player;
      this.field = field;
      this.background = background;
      this.particles = particles;
      super(n);
    }

    protected override function createActor():Actor {
      return new Bullet(buffer, player, field, background, this, particles);
    }

    public function checkHitToPlayer(p:Vector):Boolean {
      for (var i:int = 0; i < actorNum; i++)
        if (Bullet(actors[i]).checkHitToPlayer(p))
          return true;
      return false;
    }

    public function removeTainted(scoreboards:ScoreboardPool, scoreAdd:Boolean):int {
      var c:int = 0;
      for (var i:int = 0; i < actorNum; i++) {
        var b:Bullet = Bullet(actors[i]);
        if (b.tainted) {
          b.addParticles();
          if (scoreAdd) {
            c++;
            if (scoreboards.hasNextInstance) {
              var sb:Scoreboard = Scoreboard(scoreboards.getInstance());
              sb.add(b.pos.x, b.pos.y, c, c, 10);
            } else {
              field.addScore(c);
            }
          }
          b.remove();
          i--;
        }
      }
      return c;
    }
  }
}
