/*
 * $Id: Particle.as,v 1.1.1.1 2007/04/01 08:25:41 kenta Exp $
 *
 * Copyright 2007 Kenta Cho. Some rights reserved.
 */
package abagames.la2 {
  import flash.display.BitmapData;
  import flash.geom.Rectangle;
  import abagames.util.Vector;
  import abagames.util.Actor;

  /**
   * Particle.
   */
  public class Particle extends Actor {
    private var rect:Rectangle;
    private var buffer:BitmapData;
    private var field:Field;
    private var background:Background;
    private var pos:Vector;
    private var vel:Vector;
    private var cnt:int;
    private var r:int;
    private var g:int;
    private var b:int;
    private var color:int;
    private var size:Vector;

    public function Particle(buffer:BitmapData, field:Field, background:Background) {
      this.buffer = buffer;
      this.field = field;
      this.background = background;
      pos = new Vector;
      vel = new Vector;
      rect = new Rectangle(0, 0, 3, 3);
      size = new Vector(3, 3);
    }

    public function add(x:Number, y:Number, d:Number, s:Number, r:int, g:int, b:int):void {
      pos.x = x;
      pos.y = y;
      vel.x = Math.sin(d) * s;
      vel.y = Math.cos(d) * s;
      this.r = r;
      this.g = g;
      this.b = b;
      cnt = Math.random() * 15 + 45;
    }

    public override function update():void {
      pos.x += vel.x;
      pos.y += vel.y;
      vel.x *= 0.92;
      vel.y *= 0.92;
      rect.x = pos.x - 1 - field.offset.x;
      rect.y = pos.y - 1 - field.offset.y;
      color = 0x10000 * int(r * Math.random()) + 0x100 * int(g * Math.random()) + int(b * Math.random());
      buffer.fillRect(rect, color);
      background.addShadow(pos.x - 1, pos.y - 1, size);
      cnt--;
      if (cnt <= 0)
        remove();
    }
  }
}
