/*
 * $Id: Scoreboard.as,v 1.1.1.1 2007/04/01 08:25:41 kenta Exp $
 *
 * Copyright 2007 Kenta Cho. Some rights reserved.
 */
package abagames.la2 {
  import abagames.util.Vector;
  import abagames.util.Actor;

  /**
   * Scoreboard that indicates an added score.
   */
  public class Scoreboard extends Actor {
    private var field:Field;
    private var pos:Vector;
    private var vel:Vector;
    private var size:Number;
    private var num:int;
    private var cnt:int;
    private var duration:int;

    public function Scoreboard(field:Field) {
      this.field = field;
      pos = new Vector;
      vel = new Vector;
    }

    public function add(x:Number, y:Number, n:int, c:int, d:int):void {
      pos.x = x;
      pos.y = y;
      vel.x = (field.size.x / 2 - x) * 0.03;
      vel.y = (field.size.y / 2 - y) * 0.03;
      num = n;
      size = 0.1;
      cnt = -c;
      duration = d;
    }

    public override function update():void {
      cnt++;
      if (cnt < 0)
        return;
      else if (cnt == 0)
        field.addScore(num);
      pos.x += vel.x;
      pos.y += vel.y;
      vel.x *= 0.95;
      vel.y += (-1 - vel.y) * 0.05;
      size += (1 - size) * 0.05;
      Letter.drawNum(num, pos.x, pos.y, size, true);
      if (cnt > duration)
        remove();
    }
  }
}
