/*
 * $Id: Barrage.as,v 1.1 2007/04/04 13:08:57 kenta Exp $
 *
 * Copyright 2007 Kenta Cho. Some rights reserved.
 */
package abagames.la2.barrage {
  import abagames.util.Vector;
  import abagames.la2.Bullet;
  import abagames.la2.BulletPool;
  import abagames.la2.Particle;
  import abagames.la2.ParticlePool;
  import abagames.la2.Player;

  /**
   * Base class of a turrets' barrage pattern.
   */
  public class Barrage {
    protected var bullets:BulletPool;
    protected var particles:ParticlePool;
    protected var player:Player;

    public function Barrage(bullets:BulletPool, particles:ParticlePool, player:Player) {
      this.bullets = bullets;
      this.particles = particles;
      this.player = player;
    }

    public function update(pos:Vector, state:BarrageState):void { }

    protected function fire(pos:Vector, deg:Number, speed:Number, tainted:Boolean = false):Boolean {
      if (!bullets.hasNextInstance)
        return false;
      var b:Bullet = Bullet(bullets.getInstance());
      b.add(pos.x, pos.y, deg, speed, tainted);
      for (var i:int = 0; i < 5; i++) {
        var p:Particle = Particle(particles.getInstanceForced());
        p.add(pos.x, pos.y, deg + Math.random() * 0.2 - 0.1, speed * (2 + Math.random()), 100, 200, 200);
      }
      return true;
    }
  }
}
